package aeronexus.models;

import java.util.ArrayList;
import java.util.Date;

public class Mouvement {
	private int id;
	private String codeVol;
	private String numeroVol;
	/**
	 * date et heure de depart prévues
	 */
	private Date dateHeureDepart;
	/**
	 * date et heure d'arrivée prévues
	 */
	private Date dateHeureArrivee;
	/**
	 * la durée du vol est exprimée en minutes
	 */
	private int dureeVol;
	private Avion avionUtilise;
	private Aeroport aeroportDepart;
	private Aeroport aeroportArrivee;
	private ArrayList<Retard> lesRetards;

	/**
	 * constructeur qui valorise les attributs privés et instancie la collection
	 * lesRetards
	 * 
	 * @param id
	 * @param codeVol
	 * @param numeroVol
	 * @param dateHeureDepart
	 * @param dateHeureArrivee
	 * @param dureeVol
	 * @param avionUtilise
	 * @param aeroportDepart
	 * @param aeroportArrivee
	 */
	public Mouvement(int id, String codeVol, String numeroVol,
			Date dateHeureDepart, Date dateHeureArrivee,
			int dureeVol, Avion avionUtilise, Aeroport aeroportDepart,
			Aeroport aeroportArrivee) {
	}

	/**
	 * retourne l’aéroport de départ
	 * 
	 * @return
	 */
	public Aeroport getAeroportDepart() {
		return aeroportDepart;
	}

	/**
	 * retourne l’aéroport d’arrivée
	 * 
	 * @return
	 */
	public Aeroport getAeroportArrivee() {
		return aeroportArrivee;
	}

	/**
	 * Ajoute un retard au Mouvement
	 * 
	 * @param r
	 */
	public void ajouteRetard(Retard r) {
		lesRetards.add(r);
	}

	/**
	 * Calcule le retard total du mouvement
	 * 
	 * @return
	 */
	public int retardTotal() {
		int res = 0;
		for (Retard r : lesRetards) {
			res = r.getDuree();
		}
		return res;
	}

	/**
	 * Retourne la durée réelle du mouvement : durée prévue du vol + somme des
	 * retards
	 * 
	 * @return
	 */
	public int dureeReelle() {
		// TODO Question 2.2
		return 0;
	}

	/**
	 * Reçoit en paramètre une situation représentée par le code ‘AV’ (Avant
	 * Vol) si on veut Calculer le retard dont l’aéroport de départ est
	 * responsable, ou le code ‘AP’ (Après Vol) si on veut calculer le retard
	 * dont l’aéroport d’arrivée est responsable Retourne la durée totale des
	 * retards du mouvement dans cette situation pour lesquels l’aéroport est
	 * responsable
	 * 
	 * @param situation
	 * @return
	 */
	public int dureeRetardResponsable(String situation) {
		// TODO question 2.3
		return 0;
	}
}